/// The time range where a check was failing.
#[derive(
    Debug,
    Clone,
    conjure_object::serde::Serialize,
    conjure_object::serde::Deserialize,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash
)]
#[serde(crate = "conjure_object::serde")]
#[conjure_object::private::staged_builder::staged_builder]
#[builder(crate = conjure_object::private::staged_builder, update, inline)]
pub struct Failure {
    #[builder(
        default,
        custom(
            type = impl
            Into<Option<super::super::super::super::api::Timestamp>>,
            convert = |v|v.into().map(Box::new)
        )
    )]
    #[serde(rename = "startInclusive", skip_serializing_if = "Option::is_none", default)]
    start_inclusive: Option<Box<super::super::super::super::api::Timestamp>>,
    #[builder(
        default,
        custom(
            type = impl
            Into<Option<super::super::super::super::api::Timestamp>>,
            convert = |v|v.into().map(Box::new)
        )
    )]
    #[serde(rename = "endExclusive", skip_serializing_if = "Option::is_none", default)]
    end_exclusive: Option<Box<super::super::super::super::api::Timestamp>>,
}
impl Failure {
    /// Constructs a new instance of the type.
    #[inline]
    pub fn new() -> Self {
        Self::builder().build()
    }
    #[inline]
    pub fn start_inclusive(
        &self,
    ) -> Option<&super::super::super::super::api::Timestamp> {
        self.start_inclusive.as_ref().map(|o| &**o)
    }
    #[inline]
    pub fn end_exclusive(&self) -> Option<&super::super::super::super::api::Timestamp> {
        self.end_exclusive.as_ref().map(|o| &**o)
    }
}
